//#include <SoftwareSerial.h>
#include <Multiservo.h>
#include <Wire.h>
#include <IRremote.h>
#define INA 10
#define INB 11
#define EN 9
#define PWM 12
Multiservo myservo;

IRrecv irrecv(44); // pin Transceiver
decode_results results;

byte pos = 65;
byte motorSpeed = 36;
byte motorSpeed2 = 36;
byte motorSpeed3 = 40;
byte motorSpeedEasy = 24;
byte motorStop = 0;
byte val = 0;

int pinRed =  7;
int pinYellow = 6;
int pinGreen = 5;

int leftFront = 22;
int rightFront = 23;
int leftBack = 33;
int rightBack = 30;
int leftStop = 32;
int rightStop = 31;

byte sLight1 = 49;
byte sLight2 = 50;
byte sLight3 = 51;
byte sLight4 = 52;
byte sLight5 = 53;

byte sL1, sL2, sL3, sL4, sL5;

long previousMillis = 0;
long interval = 500;
byte ledState = LOW;

char inputCmd = 0;

void setup()
{
  Serial.begin(9600);
  Wire.begin();
  myservo.attach(10);
  myservo.write(pos);
  pinMode(leftFront, OUTPUT);
  pinMode(rightFront, OUTPUT);
  pinMode(leftBack, OUTPUT);
  pinMode(rightBack, OUTPUT);
  pinMode(leftStop, OUTPUT);
  pinMode(rightStop, OUTPUT);
  pinMode(INA, OUTPUT);
  pinMode(INB, OUTPUT);
  pinMode(EN, OUTPUT);
  digitalWrite(EN, HIGH);

  pinMode(pinGreen, OUTPUT);
  pinMode(pinYellow, OUTPUT);
  pinMode(pinRed, OUTPUT);

  irrecv.enableIRIn(); // запускаем прием
}
////////////////////////////////////////////////////
void sensor()  {
  sL1 = digitalRead(sLight1);
  sL2 = digitalRead(sLight2);
  sL3 = digitalRead(sLight3);
  sL4 = digitalRead(sLight4);
  sL5 = digitalRead(sLight5);
}
///////////////////////////////////////////////////
void PovLeftHigh() {
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis > interval)
  {
    previousMillis = currentMillis;
    if (ledState == LOW)
      ledState = HIGH;
    else
      ledState = LOW;
    digitalWrite(leftFront, ledState);
    digitalWrite(leftBack, ledState);
  }
}
//////////////////////////////////////////////////
void PovLR_Low() {
  digitalWrite(leftFront, LOW);
  digitalWrite(leftBack, LOW);
  digitalWrite(rightFront, LOW);
  digitalWrite(rightBack, LOW);
}
////////////////////////////////////////////////////////////////
void PovRightHigh() {
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis > interval)
  {
    previousMillis = currentMillis;
    if (ledState == LOW)
      ledState = HIGH;
    else
      ledState = LOW;
    digitalWrite(rightFront, ledState);
    digitalWrite(rightBack, ledState);
  }
}
///////////////////////////////////////////////////

void forward() {
  sensor();
  digitalWrite(INA, LOW);
  digitalWrite(INB, HIGH);
  digitalWrite(leftStop, LOW);
  digitalWrite(rightStop, LOW);

  if (sL1 == 1 && sL2 == 0 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(38);
    analogWrite(PWM, motorSpeed2);
    PovLeftHigh();
  }
  if (sL1 == 1 && sL2 == 1 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(46);
    analogWrite(PWM, motorSpeed2);
    PovLeftHigh();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(53);
    analogWrite(PWM, motorSpeed);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 1 && sL4 == 0 && sL5 == 0) {
    myservo.write(60);
    analogWrite(PWM, motorSpeed);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 0 && sL5 == 0) {
    myservo.write(65);
    analogWrite(PWM, motorSpeed);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 1 && sL5 == 0) {
    myservo.write(70);
    analogWrite(PWM, motorSpeed);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 1 && sL5 == 0) {
    myservo.write(77);
    analogWrite(PWM, motorSpeed);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 1 && sL5 == 1) {
    myservo.write(84);
    analogWrite(PWM, motorSpeed3);
    PovRightHigh();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 0 && sL5 == 1) {
    myservo.write(92);
    analogWrite(PWM, motorSpeed3);
    PovRightHigh();
  }
  else {
    myservo.write(65);
    analogWrite(PWM, motorSpeed);
    PovLR_Low();
  }
}
/////////////////////////////////////////////////////
void Stop() {
  sensor();
  digitalWrite(leftStop, HIGH);
  digitalWrite(rightStop, HIGH);

  if (sL1 == 1 && sL2 == 0 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(38);
    analogWrite(PWM, motorSpeedEasy);
    PovLeftHigh();
  }
  if (sL1 == 1 && sL2 == 1 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(46);
    analogWrite(PWM, motorSpeedEasy);
    PovLeftHigh();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(53);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 1 && sL4 == 0 && sL5 == 0) {
    myservo.write(60);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 0 && sL5 == 0) {
    myservo.write(65);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 1 && sL5 == 0) {
    myservo.write(70);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 1 && sL5 == 0) {
    myservo.write(77);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 0 && sL4 == 1 && sL5 == 1) {
    myservo.write(84);
    analogWrite(PWM, motorSpeedEasy);
    PovRightHigh();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 0 && sL5 == 1) {
    myservo.write(92);
    analogWrite(PWM, motorSpeedEasy);
    PovRightHigh();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 1 && sL5 == 1) {
    myservo.write(65);
    analogWrite(PWM, 0);
    digitalWrite(INA, HIGH);
    digitalWrite(INB, HIGH);
    delay(1000);
  }
}

void notice() {
  sensor();
  digitalWrite(leftStop, HIGH);
  digitalWrite(rightStop, HIGH);

  if (sL1 == 1 && sL2 == 0 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(38);
    analogWrite(PWM, motorSpeedEasy);
    PovLeftHigh();
  }
  if (sL1 == 1 && sL2 == 1 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(46);
    analogWrite(PWM, motorSpeedEasy);
    PovLeftHigh();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 0 && sL4 == 0 && sL5 == 0) {
    myservo.write(53);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 1 && sL4 == 0 && sL5 == 0) {
    myservo.write(60);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 0 && sL5 == 0) {
    myservo.write(65);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 1 && sL5 == 0) {
    myservo.write(70);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 1 && sL5 == 0) {
    myservo.write(77);
    analogWrite(PWM, motorSpeedEasy);
    PovLR_Low();
  }
  if (sL1 == 0 && sL2 == 1 && sL3 == 0 && sL4 == 1 && sL5 == 1) {
    myservo.write(84);
    analogWrite(PWM, motorSpeedEasy);
    PovRightHigh();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 0 && sL4 == 0 && sL5 == 1) {
    myservo.write(92);
    analogWrite(PWM, motorSpeedEasy);
    PovRightHigh();
  }
  if (sL1 == 0 && sL2 == 0 && sL3 == 1 && sL4 == 1 && sL5 == 1) {
    myservo.write(65);
    analogWrite(PWM, 0);
    digitalWrite(INA, HIGH);
    digitalWrite(INB, HIGH);
  }
}

void receiveCmd() {
  if ( irrecv.decode( &results )) {
    switch (results.value) {
      case 0: //Red ON   ///////////////////////////////
        val = 0;
        digitalWrite(pinRed, HIGH);
        digitalWrite(pinYellow, LOW);
        digitalWrite(pinGreen, LOW);
        break;

      case 1: //RedYellow   ///////////////////////////
        val = 1;
        digitalWrite(pinRed, HIGH);
        digitalWrite(pinYellow, HIGH);
        digitalWrite(pinGreen, LOW);
        break;

      case 2: //Green ON    //////////////////////////
        val = 2;
        digitalWrite(pinRed, LOW);
        digitalWrite(pinYellow, LOW);
        digitalWrite(pinGreen, HIGH);
        break;

      case 3: //Blinking Green///////////////////////
        val = 3;
        digitalWrite(pinRed, LOW);
        digitalWrite(pinYellow, LOW);
        digitalWrite(pinGreen, HIGH);
        break;

      case 4: //Yellow      ///////////////////////
        val = 4;
        digitalWrite(pinRed, LOW);
        digitalWrite(pinYellow, HIGH);
        digitalWrite(pinGreen, LOW);
        break;

    }
    Serial.println( results.value, HEX ); // печатаем данные
    irrecv.resume(); // принимаем следующую команду
  }
}


//////////////////////////////////////////////////////
void loop () {
  receiveCmd();
  if (val == 2 || val == 3)
  {
    forward();
  }
  if (val == 1)
  {
    notice();
  }
  else
  {
    Stop();
  }
}
